#INCLUDE "dcdialog.CH"

FUNCTION Main

LOCAL GetList[0], oBrowse, GetOptions

DC_LoadRdds()

USE CUSTOMER INDEX CUSTOMER VIA 'FOXCDX'

@ 0,0 DCBROWSE oBrowse ALIAS 'customer' SIZE 80,12 ;
      PRESENTATION DC_BrowPres() FIT RBSELECT

DCBROWSECOL DATA {|x|GetStatus(CUSTOMER->status)} ;
      PARENT oBrowse HEADER 'Status' WIDTH 10 ;
      EVAL {|oB|oB:dataArea:rbClick := ;
        {|a,b,o|IIF(oBrowse:colPos=1,SetStatus(CUSTOMER->status,oBrowse),nil)}}

DCBROWSECOL FIELD CUSTOMER->bill_name PARENT oBrowse HEADER 'Name' WIDTH 20
DCBROWSECOL FIELD CUSTOMER->bill_strt PARENT oBrowse HEADER 'Address' WIDTH 20
DCBROWSECOL FIELD CUSTOMER->bill_city PARENT oBrowse HEADER 'City' WIDTH 20

DCGETOPTIONS AUTORESIZE

DCREAD GUI FIT ADDBUTTONS MODAL SETAPPWINDOW ;
     OPTIONS GetOptions ;
     TITLE 'Click in Column 1 to Change Status'

RETURN nil

* ---------

PROC appsys ; RETURN

* ---------

STATIC FUNCTION GetStatus( nStatus, aStatus )

LOCAL cStatus

IF nStatus == 0
  nStatus := 1
ENDIF

aStatus := { 'Unknown', ;
             'Very Nice', ;
             'Belligerent', ;
             'Cantankerous', ;
             'Insulent', ;
             'Uninformed' }

IF nStatus > 0 .AND. nStatus <= Len(aStatus)
  cStatus := aStatus[nStatus]
ENDIF

RETURN cStatus

* ---------

STATIC FUNCTION SetStatus( nStatus, oBrowse )

LOCAL aStatus, lStatus, GetList[0], GetOptions, i

GetStatus( @nStatus, @aStatus )

FOR i := 1 TO Len(aStatus)
  @ i,1 DCRADIO nStatus VALUE i PROMPT aStatus[i] ;
    ACTION {|o|o:getData(),DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
NEXT

DCGETOPTIONS ORIGIN XBPDLG_ORIGIN_MOUSE

DCREAD GUI FIT TITLE 'Status' MODAL TO lStatus OPTIONS GetOptions

IF lStatus
  CUSTOMER->(dbRLock())
  CUSTOMER->status := nStatus
  CUSTOMER->(dbRUnlock())
  oBrowse:refreshCurrent()
ENDIF

RETURN nStatus
